<div align="center">
    <img src="encompass-logo-and-text.png?raw=true" alt="Encompass" width="400">
    <h1>
    <p></p>
    <a href="https://travis-ci.org/encompass-ecs/encompass-ts"><img alt="Build Status" src="https://img.shields.io/travis/encompass-ecs/encompass-ts/master.svg?style=for-the-badge" /></a>
    <a href="https://codecov.io/gh/encompass-ecs/encompass-ts"><img alt="Code Coverage" src="https://img.shields.io/codecov/c/gh/encompass-ecs/encompass-ts.svg?logo=codecov&style=for-the-badge" /></a>
    <a href="https://discord.gg/ZYE88fK"><img alt="Discord Chat" src="https://img.shields.io/discord/571020752904519693.svg?logo=discord&style=for-the-badge" /></a>
    </h1>
</div>

A TypeScript implementation of Encompass, a powerful engine-agnostic Hyper ECS framework for game development.

Object-oriented game code is messy and unmaintainable.
Encompass lets you write clean, de-coupled code so you can spend more time refining your design and less time fixing bugs.

Fully supports the [TypescriptToLua](https://github.com/TypeScriptToLua/TypeScriptToLua) project. Write your games in TypeScript and compile to Lua! We love [LÖVE](https://love2d.org)!

## Documentation

Docs and Tutorial:
https://encompass-ecs.github.io/

API:
https://encompass-ts.readthedocs.io

## Starter Templates

LOVE: https://github.com/encompass-ecs/encompass-love2d-starter

## Example Projects

Some example projects are complete or in active development.

### JS
* Vapor FM frontend: https://github.com/encompass-ecs/encompass-vapor-fm

### Lua
* Pong: https://github.com/encompass-ecs/encompass-pong-example
* Game of Life: https://github.com/encompass-ecs/encompass-game-of-life
* Hyperspace: https://gitlab.com/ehemsley/hyperspace-ts
