import { Engine } from "../engine";
import { Message } from "../message";
/**
 * A Spawner is a special subtype of Engine which is intended
 * to read one single type of Message and create a new Entity
 * in response.
 */
export declare abstract class Spawner extends Engine {
    update(): void;
    protected abstract spawn(message: Message): void;
}
