"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class IllegalComponentMutationError {
    constructor(engine_name, component_type) {
        this.engine_name = engine_name;
        this.component_type = component_type;
    }
    toString() {
        return this.engine_name + " tried to mutate an undeclared component of type: " + this.component_type.name;
    }
}
exports.IllegalComponentMutationError = IllegalComponentMutationError;
