export declare class PriorityQueue<T> {
    protected items: Map<number, T>;
    protected priority_map: Map<T, number>;
    protected _size: number;
    readonly size: number;
    add(value: T, priority: number): void;
    find_min(): T;
    delete_min(): T;
    empty(): boolean;
    /**
     * Iterates from lowest to highest.
     */
    to_array(): T[];
    private delete;
    private insert;
}
