import { DrawComponent } from "./draw_component";
import { IDrawable } from "./interfaces/drawable";
import { Renderer } from "./renderer";
import { EntityRenderer } from "./renderers/entity";
import { GeneralRenderer } from "./renderers/general";
export declare class TypeGuard {
    static drawable_is_draw_component(drawable: IDrawable): drawable is DrawComponent;
    static drawable_is_general_renderer(drawable: IDrawable): drawable is GeneralRenderer;
    static renderer_is_entity_renderer(renderer: Renderer): renderer is EntityRenderer;
    static renderer_is_general_renderer(renderer: Renderer): renderer is GeneralRenderer;
}
