--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 2,["6"] = 2,["7"] = 6,["8"] = 6,["9"] = 7,["10"] = 7,["11"] = 20,["12"] = 20,["13"] = 20,["14"] = 20,["15"] = 20,["16"] = 20,["17"] = 20,["18"] = 20,["19"] = 20,["27"] = 20,["28"] = 23,["30"] = 25,["31"] = 26,["32"] = 27,["33"] = 28,["36"] = 32,["37"] = 33,["38"] = 34,["39"] = 35,["40"] = 35,["42"] = 36,["44"] = 39,["45"] = 40,["46"] = 41,["47"] = 42,["48"] = 43,["50"] = 45,["52"] = 48,["53"] = 49});
local ____exports = {}
local __TSTL_engine = require("encompass-ecs.engine")
local Engine = __TSTL_engine.Engine
local __TSTL_entity_checker = require("encompass-ecs.engines.utility.entity_checker")
local EntityChecker = __TSTL_entity_checker.EntityChecker
local __TSTL_entity_tracker = require("encompass-ecs.engines.utility.entity_tracker")
local EntityTracker = __TSTL_entity_tracker.EntityTracker
____exports.Detector = {}
local Detector = ____exports.Detector
Detector.name = "Detector"
Detector.__index = Detector
Detector.prototype = {}
Detector.prototype.__index = Detector.prototype
Detector.prototype.constructor = Detector
Detector.____super = Engine
setmetatable(Detector, Detector.____super)
setmetatable(Detector.prototype, Detector.____super.prototype)
function Detector.new(...)
    local self = setmetatable({}, Detector.prototype)
    self:____constructor(...)
    return self
end
function Detector.prototype.____constructor(self, ...)
    Engine.prototype.____constructor(self, ...)
    self.entity_tracker = EntityTracker.new()
end
function Detector.prototype.update(self, dt)
    for id in self.entity_tracker.tracked_ids:entries() do
        local entity = self:get_entity(id)
        self:detect(entity, dt)
    end
end
function Detector.prototype.check_and_track_entity(self, entity_id)
    local entity = self:get_entity(entity_id)
    local should_track = EntityChecker:check_entity(entity, self.component_types)
    if should_track then
        self.entity_tracker:track_entity(entity_id)
    end
    return should_track
end
function Detector.prototype.check_and_untrack_entity(self, entity_id)
    local entity = self:get_entity(entity_id)
    local should_untrack = entity == nil or not EntityChecker:check_entity(entity, self.component_types)
    if should_untrack then
        self.entity_tracker:untrack_entity(entity_id)
    end
    return should_untrack
end
function Detector.prototype.is_tracking(self, id)
    return self.entity_tracker.tracked_ids:has(id)
end
return ____exports
