--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["19"] = 2,["20"] = 3,["23"] = 6,["25"] = 9,["26"] = 10,["27"] = 11,["29"] = 13,["32"] = 17,["33"] = 18,["34"] = 19,["35"] = 20,["38"] = 24,["39"] = 24,["40"] = 25,["41"] = 26,["44"] = 30,["45"] = 31,["47"] = 34,["48"] = 35,["49"] = 36,["50"] = 37,["51"] = 37,["52"] = 37,["53"] = 37,["55"] = 40});
local ____exports = {}
____exports.Graph = {}
local Graph = ____exports.Graph
Graph.name = "Graph"
Graph.__index = Graph
Graph.prototype = {}
Graph.prototype.____getters = {}
Graph.prototype.__index = __TS__Index(Graph.prototype)
Graph.prototype.constructor = Graph
function Graph.new(...)
    local self = setmetatable({}, Graph.prototype)
    self:____constructor(...)
    return self
end
function Graph.prototype.____constructor(self)
    self._vertices = {}
    self._edges = Map.new()
end
function Graph.prototype.____getters.vertices(self)
    return self._vertices
end
function Graph.prototype.neighbors(self, vertex)
    if self:vertex_exists(vertex) then
        return {unpack(self._edges:get(vertex))}
    else
        return {}
    end
end
function Graph.prototype.add_vertex(self, vertex)
    if not self:vertex_exists(vertex) then
        __TS__ArrayPush(self._vertices, vertex)
        self._edges:set(vertex, {})
    end
end
function Graph.prototype.add_vertices(self, ...)
    local vertices = ({...})
    for ____, vertex in ipairs(vertices) do
        self:add_vertex(vertex)
    end
end
function Graph.prototype.vertex_exists(self, vertex)
    return __TS__ArrayIndexOf(self.vertices, vertex) ~= -1
end
function Graph.prototype.remove_vertex(self, v)
    if self:vertex_exists(v) then
        for ____, u in ipairs(self:neighbors(v)) do
            self:remove_edge({
                v,
                u,
            })
        end
        __TS__ArraySplice(self.vertices, __TS__ArrayIndexOf(self.vertices, v), 1)
    end
end
return ____exports
