--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 1,["10"] = 1,["11"] = 1,["12"] = 1,["19"] = 2,["20"] = 3,["21"] = 4,["24"] = 7,["26"] = 10,["27"] = 11,["28"] = 11,["29"] = 12,["30"] = 13,["34"] = 17,["36"] = 20,["37"] = 21,["39"] = 24,["40"] = 25,["41"] = 26,["42"] = 27,["44"] = 30,["45"] = 31,["47"] = 37,["48"] = 38,["49"] = 39,["50"] = 40,["52"] = 42,["53"] = 43,["54"] = 44,["55"] = 45,["57"] = 47,["59"] = 50,["60"] = 51,["61"] = 52,["62"] = 53,["63"] = 54,["64"] = 55,["65"] = 56,["66"] = 57,["67"] = 58,["68"] = 59,["69"] = 60,["71"] = 62,["73"] = 64,["76"] = 68,["77"] = 69,["78"] = 70,["79"] = 71,["80"] = 72,["82"] = 74,["83"] = 75,["84"] = 76});
local ____exports = {}
____exports.PriorityQueue = {}
local PriorityQueue = ____exports.PriorityQueue
PriorityQueue.name = "PriorityQueue"
PriorityQueue.__index = PriorityQueue
PriorityQueue.prototype = {}
PriorityQueue.prototype.____getters = {}
PriorityQueue.prototype.__index = __TS__Index(PriorityQueue.prototype)
PriorityQueue.prototype.constructor = PriorityQueue
function PriorityQueue.new(...)
    local self = setmetatable({}, PriorityQueue.prototype)
    self:____constructor(...)
    return self
end
function PriorityQueue.prototype.____constructor(self)
    self.items = Map.new()
    self.priority_map = Map.new()
    self._size = 0
end
function PriorityQueue.prototype.____getters.size(self)
    return self._size
end
function PriorityQueue.prototype.add(self, value, priority)
    for ____TS_value in __TS__Iterator(self.items) do
        local index, v = unpack(____TS_value)
        if priority < self.priority_map:get(v) then
            self:insert(index, value, priority)
            return
        end
    end
    self:insert(self._size, value, priority)
end
function PriorityQueue.prototype.find_min(self)
    return self.items:get(0)
end
function PriorityQueue.prototype.delete_min(self)
    local min = self.items:get(0)
    self:delete(0)
    return min
end
function PriorityQueue.prototype.empty(self)
    return self.size == 0
end
function PriorityQueue.prototype.to_array(self)
    local entry_array = {}
    for entry in __TS__Iterator(self.items:entries()) do
        __TS__ArrayPush(entry_array, entry)
    end
    local sorted_array = __TS__ArraySort(entry_array, function(____, a, b) return a[1] - b[1] end)
    local values = {}
    for ____, entry in ipairs(sorted_array) do
        __TS__ArrayPush(values, entry[2])
    end
    return values
end
function PriorityQueue.prototype.delete(self, index)
    if self.items:has(index) then
        local value = self.items:get(index)
        self.items:delete(index)
        self.priority_map:delete(value)
        local k = index
        self._size = self._size - 1
        while k < self.size do
            local one_up_value = self.items:get(k + 1)
            if one_up_value ~= nil then
                self.items:set(k, one_up_value)
            end
            k = k + 1
        end
        self.items:delete(self.size)
    end
end
function PriorityQueue.prototype.insert(self, index, value, priority)
    local k = self._size
    while k > index do
        self.items:set(k, self.items:get(k - 1))
        k = k - 1
    end
    self.items:set(index, value)
    self.priority_map:set(value, priority)
    self._size = self._size + 1
end
return ____exports
