--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 5,["10"] = 5,["11"] = 6,["12"] = 6,["13"] = 11,["14"] = 11,["15"] = 11,["16"] = 11,["17"] = 11,["18"] = 11,["19"] = 11,["26"] = 12,["27"] = 13,["28"] = 15,["29"] = 17,["31"] = 20,["32"] = 23,["33"] = 24,["34"] = 25,["35"] = 27,["36"] = 28,["38"] = 32,["39"] = 35,["40"] = 36,["41"] = 37,["42"] = 38,["43"] = 39,["45"] = 43,["46"] = 45,["47"] = 46,["48"] = 47,["49"] = 48,["51"] = 51,["52"] = 52,["53"] = 53,["55"] = 56,["56"] = 57,["58"] = 60,["60"] = 63,["61"] = 64,["62"] = 65,["64"] = 67,["67"] = 71,["68"] = 72,["69"] = 73,["71"] = 75,["73"] = 78,["74"] = 79,["75"] = 80,["77"] = 82});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
local GCOptimizedMap = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedMap
local GCOptimizedSet = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedSet
local __TSTL_message_pool = require("encompass-ecs.message_pool")
local MessagePool = __TSTL_message_pool.MessagePool
local __TSTL_message_query = require("encompass-ecs.message_query")
local MessageQuery = __TSTL_message_query.MessageQuery
____exports.MessageManager = {}
local MessageManager = ____exports.MessageManager
MessageManager.name = "MessageManager"
MessageManager.__index = MessageManager
MessageManager.prototype = {}
MessageManager.prototype.__index = MessageManager.prototype
MessageManager.prototype.constructor = MessageManager
function MessageManager.new(...)
    local self = setmetatable({}, MessageManager.prototype)
    self:____constructor(...)
    return self
end
function MessageManager.prototype.____constructor(self)
    self.message_query = MessageQuery.new()
    self.messages = GCOptimizedSet.new()
    self.message_pools = GCOptimizedMap.new()
    self.message_type_to_messages_map = GCOptimizedMap.new()
end
function MessageManager.prototype.create_component_message(self, ComponentMessageType, component)
    local component_message = self:create_or_get_message_pool(ComponentMessageType):obtain()
    component_message.component = component
    self.messages:add(component_message)
    self:cache_message_by_message_type(component_message)
    return component_message
end
function MessageManager.prototype.create_entity_message(self, EntityMessageType, entity)
    local entity_message = self:create_or_get_message_pool(EntityMessageType):obtain()
    entity_message.entity = entity
    self.messages:add(entity_message)
    self:cache_message_by_message_type(entity_message)
    return entity_message
end
function MessageManager.prototype.create_message(self, MessageType)
    local message = self:create_or_get_message_pool(MessageType):obtain()
    self.messages:add(message)
    self:cache_message_by_message_type(message)
    return message
end
function MessageManager.prototype.clear_messages(self)
    for _, message_set in self.message_type_to_messages_map:entries() do
        message_set:clear()
    end
    for message in self.messages:entries() do
        self.message_pools:get(message.type):free(message)
    end
    self.messages:clear()
end
function MessageManager.prototype.get_messages_by_message_type(self, MessageType)
    if self.message_type_to_messages_map:has(MessageType) then
        return self.message_type_to_messages_map:get(MessageType)
    else
        return GCOptimizedList.Empty
    end
end
function MessageManager.prototype.cache_message_by_message_type(self, message)
    if not self.message_type_to_messages_map:get(message.type) then
        self.message_type_to_messages_map:set(message.type, GCOptimizedList.new())
    end
    self.message_type_to_messages_map:get(message.type):add(message)
end
function MessageManager.prototype.create_or_get_message_pool(self, MessageType)
    if not self.message_pools:has(MessageType) then
        self.message_pools:set(MessageType, MessagePool.new(MessageType))
    end
    return self.message_pools:get(MessageType)
end
return ____exports
