--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 3,["9"] = 3,["10"] = 7,["11"] = 7,["12"] = 10,["13"] = 10,["14"] = 10,["15"] = 10,["16"] = 10,["17"] = 10,["18"] = 10,["24"] = 18,["25"] = 12,["26"] = 15,["27"] = 16,["28"] = 19,["29"] = 20,["31"] = 23,["32"] = 24,["34"] = 27,["35"] = 28,["36"] = 29,["37"] = 30,["38"] = 31,["39"] = 32,["40"] = 33,["41"] = 34,["42"] = 35,["43"] = 37,["44"] = 38});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedMap = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedMap
local GCOptimizedSortedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedSortedList
local __TSTL_draw_layer_manager = require("encompass-ecs.draw_layer_manager")
local DrawLayerManager = __TSTL_draw_layer_manager.DrawLayerManager
local __TSTL_type_guards = require("encompass-ecs.type_guards")
local TypeGuard = __TSTL_type_guards.TypeGuard
____exports.RenderManager = {}
local RenderManager = ____exports.RenderManager
RenderManager.name = "RenderManager"
RenderManager.__index = RenderManager
RenderManager.prototype = {}
RenderManager.prototype.__index = RenderManager.prototype
RenderManager.prototype.constructor = RenderManager
function RenderManager.new(...)
    local self = setmetatable({}, RenderManager.prototype)
    self:____constructor(...)
    return self
end
function RenderManager.prototype.____constructor(self, entity_to_id_map)
    self.draw_component_type_to_renderer = GCOptimizedMap.new()
    self.layer_index_to_drawable_set = GCOptimizedMap.new()
    self.order = GCOptimizedSortedList.new()
    self.entity_to_id_map = entity_to_id_map
    self.draw_layer_manager = DrawLayerManager.new(self.layer_index_to_drawable_set, self.order)
end
function RenderManager.prototype.register_entity_renderer(self, renderer)
    self.draw_component_type_to_renderer:set(renderer.draw_component_type, renderer)
end
function RenderManager.prototype.draw(self)
    for _, layer_index in self.order:entries() do
        for drawable in self.layer_index_to_drawable_set:get(layer_index):entries() do
            if TypeGuard:drawable_is_general_renderer(drawable) then
                drawable:render()
            elseif TypeGuard:drawable_is_draw_component(drawable) then
                if self.draw_component_type_to_renderer:has(drawable.type) then
                    local renderer = self.draw_component_type_to_renderer:get(drawable.type)
                    local entity = self.entity_to_id_map:get(drawable.entity_id)
                    if renderer:is_tracking(entity.id) then
                        renderer:render(entity)
                    end
                end
            end
        end
    end
end
return ____exports
