import { Component } from "./component";
import { DrawLayerManager } from "./draw_layer_manager";
import { Type } from "./types/generic_type";
export declare abstract class DrawComponent extends Component {
    private _layer;
    private draw_layer_manager;
    layer: number;
    constructor(DrawComponentType: Type<DrawComponent>, entity_id: number, layer_manager: DrawLayerManager<DrawComponent>);
    activate(): void;
    deactivate(): void;
    destroy(): void;
}
