"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class EntityChecker {
    static check_entity(entity, component_types) {
        let has_all_components = true;
        for (const component_type of component_types) {
            has_all_components = has_all_components && entity.has_component(component_type);
            if (!has_all_components) {
                return false;
            }
        }
        return has_all_components;
    }
}
exports.EntityChecker = EntityChecker;
