"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class EngineCycleError {
    constructor(cycles) {
        this.cycles = cycles;
    }
    toString() {
        let string = "Cycle(s) found in engines:";
        for (const cycle of this.cycles) {
            string += "\n" +
                cycle.map((engine) => engine.constructor.name).join(" -> ") +
                " -> " +
                cycle[0].constructor.name;
        }
        return string;
    }
}
exports.EngineCycleError = EngineCycleError;
