"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class SingletonReadError {
    constructor(engine_name, type) {
        this.engine_name = engine_name;
        this.element_type = type;
    }
    toString() {
        return this.engine_name + " tried to read a singleton, but multiple " + this.element_type.name + " existed";
    }
}
exports.SingletonReadError = SingletonReadError;
