--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 8,["9"] = 8,["10"] = 8,["11"] = 8,["12"] = 8,["13"] = 8,["14"] = 8,["21"] = 9,["22"] = 10,["23"] = 12,["24"] = 13,["25"] = 14,["27"] = 17,["28"] = 22,["29"] = 23,["30"] = 24,["31"] = 25,["33"] = 28,["34"] = 31,["35"] = 32,["36"] = 32,["37"] = 33,["40"] = 37,["42"] = 41,["43"] = 43,["44"] = 44,["46"] = 48,["49"] = 53,["50"] = 55,["51"] = 56,["53"] = 58,["56"] = 62,["57"] = 63,["58"] = 64,["60"] = 66,["62"] = 69,["63"] = 70,["64"] = 71,["66"] = 73,["68"] = 76,["69"] = 77,["70"] = 78,["72"] = 80,["74"] = 83,["75"] = 84,["77"] = 87,["78"] = 88,["80"] = 91,["81"] = 92,["83"] = 95,["84"] = 96,["85"] = 97,["87"] = 100,["88"] = 101,["89"] = 102,["91"] = 105,["92"] = 106,["93"] = 107});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
local GCOptimizedMap = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedMap
____exports.ComponentManager = {}
local ComponentManager = ____exports.ComponentManager
ComponentManager.name = "ComponentManager"
ComponentManager.__index = ComponentManager
ComponentManager.prototype = {}
ComponentManager.prototype.__index = ComponentManager.prototype
ComponentManager.prototype.constructor = ComponentManager
function ComponentManager.new(...)
    local self = setmetatable({}, ComponentManager.prototype)
    self:____constructor(...)
    return self
end
function ComponentManager.prototype.____constructor(self)
    self.component_type_to_active_components_map = GCOptimizedMap.new()
    self.component_type_to_inactive_components_map = GCOptimizedMap.new()
    self.components_to_activate = GCOptimizedList.new()
    self.components_to_deactivate = GCOptimizedList.new()
    self.components_to_remove = GCOptimizedList.new()
end
function ComponentManager.prototype.create_component(self, ComponentType, entity_id, draw_layer_manager, properties)
    local component = ComponentType.new(ComponentType, entity_id, draw_layer_manager)
    if not self.component_type_to_active_components_map:has(ComponentType) then
        self.component_type_to_active_components_map:set(ComponentType, GCOptimizedList.new())
        self.component_type_to_inactive_components_map:set(ComponentType, GCOptimizedList.new())
    end
    self:mark_for_activation(component)
    if properties ~= nil then
        for ____, ____TS_values in ipairs(__TS__ObjectEntries(properties)) do
            local key, value = unpack(____TS_values)
            component[key] = value
        end
    end
    return component
end
function ComponentManager.prototype.get_components_by_component_type(self, ComponentType)
    if self.component_type_to_active_components_map:has(ComponentType) then
        return self.component_type_to_active_components_map:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function ComponentManager.prototype.get_inactive_components_by_component_type(self, ComponentType)
    if self.component_type_to_inactive_components_map:has(ComponentType) then
        return self.component_type_to_inactive_components_map:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function ComponentManager.prototype.activate_components(self)
    for component in self.components_to_activate:values() do
        self:perform_activate_component(component)
    end
    self.components_to_activate:clear()
end
function ComponentManager.prototype.deactivate_components(self)
    for component in self.components_to_deactivate:values() do
        self:perform_deactivate_component(component)
    end
    self.components_to_deactivate:clear()
end
function ComponentManager.prototype.remove_components(self)
    for component in self.components_to_remove:values() do
        self:perform_remove_component(component)
    end
    self.components_to_remove:clear()
end
function ComponentManager.prototype.mark_for_activation(self, component)
    self.components_to_activate:add(component)
end
function ComponentManager.prototype.mark_for_deactivation(self, component)
    self.components_to_deactivate:add(component)
end
function ComponentManager.prototype.mark_for_removal(self, component)
    self.components_to_remove:add(component)
end
function ComponentManager.prototype.perform_remove_component(self, component)
    self.component_type_to_active_components_map:get(component.type):deleteValue(component)
    self.component_type_to_inactive_components_map:get(component.type):deleteValue(component)
end
function ComponentManager.prototype.perform_deactivate_component(self, component)
    self.component_type_to_active_components_map:get(component.type):deleteValue(component)
    self.component_type_to_inactive_components_map:get(component.type):add(component)
end
function ComponentManager.prototype.perform_activate_component(self, component)
    self.component_type_to_inactive_components_map:get(component.type):deleteValue(component)
    self.component_type_to_active_components_map:get(component.type):add(component)
end
return ____exports
