--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 7,["8"] = 7,["9"] = 8,["10"] = 8,["11"] = 9,["12"] = 9,["13"] = 10,["14"] = 10,["15"] = 29,["16"] = 29,["17"] = 29,["18"] = 29,["19"] = 29,["20"] = 29,["21"] = 29,["27"] = 40,["28"] = 30,["29"] = 31,["30"] = 32,["31"] = 45,["32"] = 46,["33"] = 47,["34"] = 48,["36"] = 56,["37"] = 57,["39"] = 68,["40"] = 70,["41"] = 71,["43"] = 73,["44"] = 74,["47"] = 86,["48"] = 89,["49"] = 90,["50"] = 91,["52"] = 102,["53"] = 105,["54"] = 106,["55"] = 107,["57"] = 115,["58"] = 116,["60"] = 127,["61"] = 129,["63"] = 140,["64"] = 142,["65"] = 143,["66"] = 144,["67"] = 145,["68"] = 146,["70"] = 148,["71"] = 149,["74"] = 163,["75"] = 165,["76"] = 166,["78"] = 168,["79"] = 169,["82"] = 183,["83"] = 185,["84"] = 186,["85"] = 187,["86"] = 188,["87"] = 189,["88"] = 190,["90"] = 192,["91"] = 193,["94"] = 196,["95"] = 197,["98"] = 207,["99"] = 208,["100"] = 209,["102"] = 211,["103"] = 212,["106"] = 223,["107"] = 225,["109"] = 235,["110"] = 237,["111"] = 238,["113"] = 240,["114"] = 241,["117"] = 252,["118"] = 254,["119"] = 255,["121"] = 257,["122"] = 258});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
local __TSTL_emit_undeclared_message = require("encompass-ecs.errors.emit_undeclared_message")
local EmitUndeclaredMessageError = __TSTL_emit_undeclared_message.EmitUndeclaredMessageError
local __TSTL_illegal_component_mutation = require("encompass-ecs.errors.illegal_component_mutation")
local IllegalComponentMutationError = __TSTL_illegal_component_mutation.IllegalComponentMutationError
local __TSTL_read_undeclared_message = require("encompass-ecs.errors.read_undeclared_message")
local ReadUndeclaredMessage = __TSTL_read_undeclared_message.ReadUndeclaredMessage
local __TSTL_singleton_read = require("encompass-ecs.errors.singleton_read")
local SingletonReadError = __TSTL_singleton_read.SingletonReadError
____exports.Engine = {}
local Engine = ____exports.Engine
Engine.name = "Engine"
Engine.__index = Engine
Engine.prototype = {}
Engine.prototype.__index = Engine.prototype
Engine.prototype.constructor = Engine
function Engine.new(...)
    local self = setmetatable({}, Engine.prototype)
    self:____constructor(...)
    return self
end
function Engine.prototype.____constructor(self, entity_manager, entity_creator, component_manager, message_manager)
    self.emit_message_types = GCOptimizedList.new()
    self.read_message_types = GCOptimizedList.new()
    self.mutate_component_types = GCOptimizedList.new()
    self.entity_manager = entity_manager
    self.entity_creator = entity_creator
    self.component_manager = component_manager
    self.message_manager = message_manager
end
function Engine.prototype.create_entity(self)
    return self.entity_creator:create_entity()
end
function Engine.prototype.emit_message(self, MessageType)
    if self.emit_message_types:hasValue(MessageType) then
        return self.message_manager:create_message(MessageType)
    else
        local message_error = EmitUndeclaredMessageError.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
function Engine.prototype.emit_component_message(self, MessageType, component)
    local message = self:emit_message(MessageType)
    message.component = component
    return message
end
function Engine.prototype.emit_entity_message(self, MessageType, entity)
    local message = self:emit_message(MessageType)
    message.entity = entity
    return message
end
function Engine.prototype.get_entity(self, entity_id)
    return self.entity_manager:get_entity(entity_id)
end
function Engine.prototype.read_components(self, ComponentType)
    return self.component_manager:get_components_by_component_type(ComponentType)
end
function Engine.prototype.read_component(self, ComponentType)
    local components = self.component_manager:get_components_by_component_type(ComponentType)
    if components.size == 0 then
        return nil
    elseif components.size == 1 then
        return components:get(0)
    else
        local multiple_component_error = SingletonReadError.new(self.constructor.name, ComponentType)
        error(tostring(multiple_component_error))
    end
end
function Engine.prototype.read_components_mutable(self, ComponentType)
    if self.mutate_component_types:hasValue(ComponentType) then
        return self.component_manager:get_components_by_component_type(ComponentType)
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, ComponentType)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.read_component_mutable(self, ComponentType)
    if self.mutate_component_types:hasValue(ComponentType) then
        local components = self.component_manager:get_components_by_component_type(ComponentType)
        if components.size == 0 then
            return nil
        elseif components.size == 1 then
            return components:get(0)
        else
            local multiple_component_error = SingletonReadError.new(self.constructor.name, ComponentType)
            error(tostring(multiple_component_error))
        end
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, ComponentType)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.make_mutable(self, component)
    if self.mutate_component_types:hasValue(component.type) then
        return component
    else
        local mutate_error = IllegalComponentMutationError.new(self.constructor.name, component.type)
        error(tostring(mutate_error))
    end
end
function Engine.prototype.read_inactive_components(self, ComponentType)
    return self.component_manager:get_inactive_components_by_component_type(ComponentType)
end
function Engine.prototype.read_messages(self, MessageType)
    if self.read_message_types:hasValue(MessageType) then
        return self.message_manager:get_messages_by_message_type(MessageType)
    else
        local message_error = ReadUndeclaredMessage.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
function Engine.prototype.some(self, MessageType)
    if self.read_message_types:hasValue(MessageType) then
        return self.message_manager:get_messages_by_message_type(MessageType).size > 0
    else
        local message_error = ReadUndeclaredMessage.new(self.constructor.name, MessageType)
        error(tostring(message_error))
    end
end
return ____exports
