--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 1,["8"] = 1,["9"] = 32,["10"] = 32,["11"] = 32,["12"] = 32,["13"] = 32,["14"] = 32,["15"] = 32,["16"] = 32,["22"] = 50,["23"] = 35,["24"] = 57,["25"] = 58,["26"] = 59,["27"] = 60,["28"] = 61,["29"] = 62,["30"] = 64,["31"] = 65,["34"] = 47,["36"] = 76,["37"] = 79,["38"] = 86,["39"] = 87,["40"] = 88,["41"] = 89,["42"] = 90,["43"] = 91,["44"] = 92,["46"] = 94,["47"] = 95,["49"] = 98,["50"] = 99,["51"] = 101,["53"] = 116,["54"] = 117,["56"] = 128,["57"] = 129,["58"] = 130,["60"] = 132,["63"] = 144,["64"] = 145,["65"] = 146,["67"] = 148,["70"] = 158,["71"] = 159,["73"] = 169,["74"] = 170,["76"] = 180,["77"] = 181,["78"] = 182,["79"] = 183,["80"] = 184,["81"] = 185,["82"] = 186,["83"] = 187,["84"] = 188,["85"] = 188,["88"] = 191,["89"] = 192,["90"] = 193,["91"] = 194,["92"] = 195,["94"] = 198,["96"] = 201,["97"] = 202,["99"] = 205,["100"] = 206,["102"] = 217,["103"] = 218,["104"] = 219,["105"] = 220,["106"] = 221,["107"] = 222,["110"] = 232,["111"] = 233,["112"] = 234,["113"] = 235,["114"] = 236,["115"] = 237,["116"] = 238,["118"] = 240,["119"] = 241,["122"] = 250,["123"] = 251});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
local GCOptimizedMap = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedMap
local GCOptimizedSet = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedSet
____exports.Entity = {}
local Entity = ____exports.Entity
Entity.name = "Entity"
Entity.__index = Entity
Entity.prototype = {}
Entity.prototype.____getters = {}
Entity.prototype.__index = __TS__Index(Entity.prototype)
Entity.prototype.constructor = Entity
function Entity.new(...)
    local self = setmetatable({}, Entity.prototype)
    self:____constructor(...)
    return self
end
function Entity.prototype.____constructor(self, id, dirty_entities_added, dirty_entities_removed, entities_marked_for_destroy, draw_layer_manager, component_manager)
    self._component_types = GCOptimizedSet.new()
    self.id = id
    self.dirty_entities_added = dirty_entities_added
    self.dirty_entities_removed = dirty_entities_removed
    self.entities_marked_for_destroy = entities_marked_for_destroy
    self.draw_layer_manager = draw_layer_manager
    self.component_manager = component_manager
    self.component_type_to_component_bag = GCOptimizedMap.new()
    self.component_type_to_active_components = GCOptimizedMap.new()
end
function Entity.prototype.____getters.component_types(self)
    return self._component_types
end
function Entity.prototype.add_component(self, ComponentType, properties)
    local component = self.component_manager:create_component(ComponentType, self.id, self.draw_layer_manager, properties)
    if not self.component_type_to_component_bag:has(ComponentType) then
        local component_bag = GCOptimizedList.new()
        local active_component_bag = GCOptimizedList.new()
        self.component_type_to_component_bag:set(ComponentType, component_bag)
        self.component_type_to_active_components:set(ComponentType, active_component_bag)
        component_bag:add(component)
        active_component_bag:add(component)
    else
        self.component_type_to_component_bag:get(ComponentType):add(component)
        self.component_type_to_active_components:get(ComponentType):add(component)
    end
    self._component_types:add(ComponentType)
    self.dirty_entities_added:add(self)
    return component
end
function Entity.prototype.get_component(self, constructor)
    return self:get_components(constructor):get(0)
end
function Entity.prototype.get_components(self, ComponentType)
    if self.component_type_to_active_components:has(ComponentType) then
        return self.component_type_to_active_components:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function Entity.prototype.get_components_including_inactive(self, ComponentType)
    if self.component_type_to_component_bag:has(ComponentType) then
        return self.component_type_to_component_bag:get(ComponentType)
    else
        return GCOptimizedList.Empty
    end
end
function Entity.prototype.has_component(self, ComponentType)
    return self.component_type_to_active_components:has(ComponentType) and not self.component_type_to_active_components:get(ComponentType):empty()
end
function Entity.prototype.has_component_including_inactive(self, ComponentType)
    return self.component_type_to_component_bag:has(ComponentType) and not self.component_type_to_component_bag:get(ComponentType):empty()
end
function Entity.prototype.remove_component(self, component)
    local component_bag = self.component_type_to_component_bag:get(component.type)
    local active_component_bag = self.component_type_to_active_components:get(component.type)
    component_bag:deleteValue(component)
    active_component_bag:deleteValue(component)
    self.dirty_entities_removed:add(self)
    self.component_manager:mark_for_removal(component)
    component:destroy()
    if component_bag:empty() then
        self._component_types:delete(component.type)
    end
end
function Entity.prototype.remove_all_components(self)
    for ____type, component_list in self.component_type_to_component_bag:entries() do
        for component in component_list:values() do
            self.component_manager:mark_for_removal(component)
            component:destroy()
        end
        component_list:clear()
    end
    for ____type, component_list in self.component_type_to_active_components:entries() do
        component_list:clear()
    end
    self._component_types:clear()
    self.dirty_entities_removed:add(self)
end
function Entity.prototype.activate_component(self, component)
    if not component.active then
        component:activate()
        self.component_type_to_active_components:get(component.type):add(component)
        self.dirty_entities_added:add(self)
        self.component_manager:mark_for_activation(component)
    end
end
function Entity.prototype.deactivate_component(self, component)
    if component.active then
        component:deactivate()
        local active_component_bag = self.component_type_to_active_components:get(component.type)
        local index = active_component_bag:indexOf(component)
        if index ~= nil then
            active_component_bag:delete(index)
        end
        self.dirty_entities_removed:add(self)
        self.component_manager:mark_for_deactivation(component)
    end
end
function Entity.prototype.destroy(self)
    self.entities_marked_for_destroy:add(self)
end
return ____exports
