--[[ Generated with https://github.com/TypeScriptToLua/TypeScriptToLua ]]
require("lualib_bundle");
__TS__SourceMapTraceBack(debug.getinfo(1).short_src, {["5"] = 1,["6"] = 1,["7"] = 4,["8"] = 4,["9"] = 4,["10"] = 4,["11"] = 4,["12"] = 4,["13"] = 4,["14"] = 4,["20"] = 39,["21"] = 40,["22"] = 40,["24"] = 41,["25"] = 41,["27"] = 42,["28"] = 42,["30"] = 44,["31"] = 45,["32"] = 46,["33"] = 48,["34"] = 50,["35"] = 51,["36"] = 52,["37"] = 53,["40"] = 5,["43"] = 6,["46"] = 7,["48"] = 56,["49"] = 57,["50"] = 58,["51"] = 59,["52"] = 60,["53"] = 61,["56"] = 64,["58"] = 66,["60"] = 69,["61"] = 70,["62"] = 71,["63"] = 72,["65"] = 74,["68"] = 78,["69"] = 79,["70"] = 80,["73"] = 84,["74"] = 85,["75"] = 86,["76"] = 87,["77"] = 88,["78"] = 89,["81"] = 93,["82"] = 94,["83"] = 95,["85"] = 97,["88"] = 9,["89"] = 11,["90"] = 12,["92"] = 15,["93"] = 16,["94"] = 17,["95"] = 18,["97"] = 21,["98"] = 23,["99"] = 24,["100"] = 25});
local ____exports = {}
local __TSTL_encompass_2Dgc_2Doptimized_2Dcollections = require("encompass-gc-optimized-collections")
local GCOptimizedList = __TSTL_encompass_2Dgc_2Doptimized_2Dcollections.GCOptimizedList
____exports.ObjectPool = {}
local ObjectPool = ____exports.ObjectPool
ObjectPool.name = "ObjectPool"
ObjectPool.__index = ObjectPool
ObjectPool.prototype = {}
ObjectPool.prototype.____getters = {}
ObjectPool.prototype.__index = __TS__Index(ObjectPool.prototype)
ObjectPool.prototype.constructor = ObjectPool
function ObjectPool.new(...)
    local self = setmetatable({}, ObjectPool.prototype)
    self:____constructor(...)
    return self
end
function ObjectPool.prototype.____constructor(self, object_constructor, object_destructor, size, overflow_behavior)
    if object_destructor == nil then
        object_destructor = ____exports.ObjectPool.DefaultDestructor
    end
    if size == nil then
        size = 16
    end
    if overflow_behavior == nil then
        overflow_behavior = ____exports.ObjectPool.OverflowBehaviorExpand
    end
    self._size = size
    self._inactive_objects = GCOptimizedList.new()
    self._active_objects = GCOptimizedList.new()
    self.reference_object = object_constructor.new(object_constructor)
    self.constructor_function = object_constructor
    self.destructor_function = object_destructor
    self.overflow_behavior = overflow_behavior
    self:generate(size)
end
function ObjectPool.prototype.____getters.size(self)
    return self._size
end
function ObjectPool.prototype.____getters.inactive_objects(self)
    return self._inactive_objects
end
function ObjectPool.prototype.____getters.active_objects(self)
    return self._active_objects
end
function ObjectPool.prototype.obtain(self)
    local object = self:get_inactive_object()
    if object ~= nil then
        for key in pairs(object) do
            if key ~= "_type" and key ~= "type" then
                object[key] = self.reference_object[key]
            end
        end
        self._active_objects:add(object)
    end
    return object
end
function ObjectPool.prototype.free(self, instance)
    if self.active_objects:deleteValue(instance) then
        self.inactive_objects:add(instance)
        self:destructor_function(instance)
    else
        error(("cannot free object which is not from pool"))
    end
end
function ObjectPool.prototype.free_all(self)
    for _, object in self.active_objects:entries() do
        self:free(object)
    end
end
function ObjectPool.prototype.generate(self, amount)
    local i = 0
    while i < amount do
        local object = self.constructor_function.new(self.constructor_function)
        self._inactive_objects:add(object)
        i = i + 1
    end
end
function ObjectPool.prototype.get_inactive_object(self)
    if self._inactive_objects.size > 0 then
        return self._inactive_objects:pop()
    else
        return self:overflow_behavior(self)
    end
end
ObjectPool.OverflowBehaviorFallible = function() return nil end
ObjectPool.OverflowBehaviorCycle = function(____, pool)
    return pool.active_objects:shift()
end
ObjectPool.OverflowBehaviorExpand = function(____, pool)
    pool:generate(pool.size)
    pool._size = pool._size * 2
    return pool._inactive_objects:pop()
end
ObjectPool.DefaultDestructor = function(____, object)
    for key in pairs(object) do
        if key ~= "_type" and key ~= "type" then
            object[key] = nil
        end
    end
end
return ____exports
