import { GCOptimizedMap } from "encompass-gc-optimized-collections";
import { DrawLayerManager } from "./draw_layer_manager";
import { Entity } from "./entity";
import { IDrawable } from "./interfaces/drawable";
import { EntityRenderer } from "./renderers/entity";
export declare class RenderManager {
    draw_layer_manager: DrawLayerManager<IDrawable>;
    private draw_component_type_to_renderer;
    private entity_to_id_map;
    private layer_index_to_drawable_set;
    private order;
    constructor(entity_to_id_map: GCOptimizedMap<number, Entity>);
    register_entity_renderer(renderer: EntityRenderer): void;
    draw(): void;
}
